%define _disable_ld_no_undefined 1

%define alternatives 	1
%if %alternatives
%define sendmail_command %{_sbindir}/sendmail.postfix
%else
%define sendmail_command %{_sbindir}/sendmail
%endif

%define post_install_parameters	daemon_directory=%{_libexecdir}/postfix command_directory=%{_sbindir} queue_directory=%{queue_directory} sendmail_path=%{sendmail_command} newaliases_path=%{_bindir}/newaliases mailq_path=%{_bindir}/mailq mail_owner=postfix setgid_group=%{maildrop_group} manpage_directory=%{_mandir} readme_directory=%{_docdir}/%{name}/README_FILES html_directory=%{_docdir}/%{name}/html data_directory=/var/lib/postfix

# use bcond_with if default is disabled
# use bcond_without if default is enabled
# built
%bcond_without ldap
%bcond_without mysql
%bcond_without pgsql
%bcond_without sdbm
%bcond_without sqlite
%bcond_without pcre
%bcond_without sasl
%bcond_without tls
%bcond_without ipv6
%bcond_without cdb
%bcond_with multiline
%bcond_with VDA
%bcond_without chroot

# Postfix requires one exlusive uid/gid and a 2nd exclusive gid for its own use.
%define maildrop_group	postdrop
%define queue_directory	%{_var}/spool/postfix

# Macro: %{dynmap_add_cmd <name> [<soname>] [-m]}
%define dynmap_add_cmd(m) FILE=%{_sysconfdir}/postfix/dynamicmaps.cf; if ! grep -q "^%{1}[[:space:]]" ${FILE}; then echo "%{1}	%{_libdir}/postfix-%{?2:%{2}}%{?!2:%{1}}.so	dict_%{1}_open%{-m:	mkmap_%{1}_open}" >> ${FILE}; fi;
%define dynmap_rm_cmd() FILE=%{_sysconfdir}/postfix/dynamicmaps.cf; if [ $1 = 0 -a -s $FILE ]; then  cp -p ${FILE} ${FILE}.$$; grep -v "^%{1}[[:space:]]" ${FILE}.$$ > ${FILE}; rm -f ${FILE}.$$; fi;

Summary:	Postfix Mail Transport Agent
Name:		postfix
Epoch:		1
Version:	3.1.4
Release:	%mkrel 2
License:	IBM Public License
Group:		System/Servers
URL:		http://www.postfix.org/
Source0: 	ftp://ftp.porcupine.org/mirrors/postfix-release/official/%{name}-%{version}.tar.gz
Source1: 	ftp://ftp.porcupine.org/mirrors/postfix-release/official/%{name}-%{version}.tar.gz.sig
Source2:	postfix-main.cf
Source3: 	postfix-etc-init.d-postfix
Source4:	postfix-etc-pam.d-smtp
Source5:	postfix-aliases
Source6:	postfix-ip-up
Source7:	postfix-ip-down
Source8:	postfix-ifup-d
Source10:	postfix-README.MGA
#Source11:	postfix-README.MGA.update
#Source11:	http://www.comedia.it/~bluca/postfix/CYRUS_README
Source12:	postfix-bash-completion
Source13:	http://www.seaglass.com/postfix/faq.html
Source14:	postfix-chroot.sh
Source15:	postfix-smtpd.conf
Source16:	postfix-syslog-ng.200900.conf
Source17:	postfix-syslog-ng.conf

# Simon J. Mudd stuff
Source21:	ftp://ftp.wl0.org/postfinger/postfinger-1.30

# Jim Seymour stuff
Source25:	http://jimsun.LinxNet.com/misc/postfix-anti-UCE.txt
Source26:	http://jimsun.LinxNet.com/misc/header_checks.txt
Source27:	http://jimsun.LinxNet.com/misc/body_checks.txt

Patch1:		postfix-3.0.0-mgaconfig.diff
Patch2:		postfix-alternatives-mdk.patch

# dbupgrade patch patch split from dynamicmaps one
Patch3:		postfix-2.9.1-dbupgrade.diff

# sdbm patch patch split from dynamicmaps one
Patch4:		postfix-2.7.0-sdbm.patch

# Shamelessy stolen from debian
Patch6:		postfix-2.2.4-smtpstone.patch

# applied if %with pam
# originally from http://d.scn.ru/proj/postfix/dict_pam/
Patch7:		postfix-2.0.16-20030921.pam.patch

# applied if %with multiline
Patch8:		ftp://ftp.wl0.org/SOURCES/postfix-2.3.2-multiline-greeting.patch

# applied if %with VDA
# http://vda.sourceforge.net/
# Postfix 2.6.5-NG: SHASUM 946770cdfe2d77a96c6652b254449ea961513081
Patch9:		http://vda.sourceforge.net/VDA/postfix-2.6.5-vda-ng.patch.gz
# Postfix 2.6.5-NG-bigquota: SHASUM 6dfeb9a2fff44d85e9a5a28b81a84898734adfe6
Patch10: 	http://vda.sourceforge.net/VDA/postfix-2.6.5-vda-ng-bigquota.patch.gz

Patch11:	postfix-3.0.3-no-warning-about-symlinks.patch

BuildRequires:	db-devel
BuildRequires:	gawk
BuildRequires:	html2text
BuildRequires:	perl-base
BuildRequires:	sed
%if %{with sasl}
BuildRequires:	libsasl-devel >= 2.0
%endif
%if %{with tls}
BuildRequires:	pkgconfig(openssl)
%endif

%define libname %mklibname postfix 1
Requires:	%{libname} = %{epoch}:%{version}-%{release}
Requires(post):	%{libname} = %{epoch}:%{version}-%{release}
# versionless require or we will break upgrades
Requires(preun):	%{libname}
# we dont, actually
Requires(postun):	%{libname}
Provides:	mail-server
Provides:	sendmail-command
# http://archives.mandrivalinux.com/cooker/2005-06/msg01987.php
Requires(post): chkconfig, initscripts, system-logger, coreutils, diffutils, gawk
Requires:	system-logger, coreutils, diffutils, gawk
Requires(pre,post,postun,preun): rpm-helper >= 0.3
Requires(pre,post):	sed
Requires:		sed
Requires(post):		openssl
%if %alternatives
Requires(post,preun):		update-alternatives
%else
Conflicts:	sendmail exim qmail
%endif
%if %{with tls}
Requires(post):		openssl
%endif
%if %{with ldap}
BuildRequires:	openldap-devel >= 2.1
%endif
%if %{with pcre}
BuildRequires:	pcre-devel
%endif
%if %{with mysql}
BuildRequires:  mariadb-devel
%endif
%if %{with pgsql}
BuildRequires:	postgresql-devel >= 8.1.4
%endif
%if %{with sqlite}
BuildRequires:	sqlite3-devel
%endif
%if %{with pam}
BuildRequires:	pam-devel
%endif
%if %{with cdb}
BuildRequires:	libtinycdb-devel
%endif

%description
Postfix is a Mail Transport Agent (MTA), supporting LDAP, SMTP AUTH (SASL),
TLS and running in a chroot environment.

Postfix is Wietse Venema's mailer that started life as an alternative 
to the widely-used Sendmail program.
Postfix attempts to be fast, easy to administer, and secure, while at 
the same time being sendmail compatible enough to not upset existing 
users. Thus, the outside has a sendmail-ish flavor, but the inside is 
completely different.
This software was formerly known as VMailer. It was released by the end
of 1998 as the IBM Secure Mailer. From then on it has lived on as Postfix. 

This rpm supports different build time options, to enable or disable these
features you must rebuild the source rpm using the --with ... or --without ...
rpm option.
Currently postfix has been built with:

	Smtpd multiline greeting: --%{with_TXT multiline}
	Virtual Delivery Agent: --%{with_TXT VDA}
	Munge bare CR: --%{with_TXT barecr}
	TLS support: --%{with_TXT tls}
	IPV6 support: --%{with_TXT ipv6}
	CDB support: --%{with_TXT cdb}
	Chroot by default: --%{with_TXT chroot}

%package -n %{libname}
Summary:	Shared libraries required to run Postfix
Group:		System/Servers

%description -n %{libname}
This package contains shared libraries used by Postfix.

%if %{with ldap}
%package ldap
Summary:	LDAP map support for Postfix
Group:		System/Servers
BuildRequires:	openldap-devel >= 2.1
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description ldap
This package provides support for LDAP maps in Postfix.
%endif

%if %{with pcre}
%package pcre
Summary:	PCRE map support for Postfix
Group:		System/Servers
BuildRequires:	pcre-devel
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description pcre
This package provides support for PCRE (perl compatible regular expression)
maps in Postfix.
%endif

%if %{with mysql}
%package mysql
Summary:	MYSQL map support for Postfix
Group:		System/Servers
BuildRequires:	mysql-devel
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description mysql
This package provides support for MYSQL maps in Postfix.
%endif

%if %{with pgsql}
%package pgsql
Summary:	Postgres SQL map support for Postfix
Group:		System/Servers
# From the release notes of postfix-2.2.11:
# The PostgreSQL client was updated after major database API changes
# in response to PostgreSQL security issues. This breaks support for
# PGSQL versions prior to 8.1.4, 8.0.8, 7.4.13, and 7.3.15. Support
# for these requires major code changes which are not possible in a
# stable release.
BuildRequires:	postgresql-devel >= 8.1.4
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description pgsql
This package provides support for Postgres SQL maps in Postfix.
%endif

%if %{with sdbm}
%package sdbm
Summary:	SDBM map support for Postfix
Group:		System/Servers
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description sdbm
This package provides support for SDBM maps in Postfix.
%endif

%if %{with sqlite}
%package sqlite
Summary:	SQLite map support for Postfix
Group:		System/Servers
BuildRequires:	sqlite3-devel
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description sqlite
This package provides support for SQLite maps in Postfix.
%endif

%if %{with pam}
%package pam
Summary:	PAM map support for Postfix
Group:		System/Servers
BuildRequires:	pam-devel
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description pam
This package provides support for PAM maps in Postfix.
%endif

%if %{with cdb}
%package cdb
Summary:	CDB map support for Postfix
Group:		System/Servers
BuildRequires:	libtinycdb-devel
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description cdb
This package provides support for CDB maps in Postfix.
%endif

%prep
%setup -q

# no backup files here, otherwise they get included in %%doc
%patch1 -p1 -b .mgaconfig
find . -name \*.mgaconfig -o -name \*.orig -exec rm {} \;
mkdir -p conf/dist
mv conf/main.cf conf/dist
cp %{SOURCE2} conf/main.cf

# ugly hack for 32/64 arches
if [ %{_lib} != lib ]; then
	sed -i -e 's@^/usr/lib/@%{_libdir}/@' conf/postfix-files
fi

%if %alternatives
%patch2 -p1 -b .alternatives
%endif

%patch3 -p1 -b .dbupgrade

%patch4 -p1 -b .sdbm 
%patch6 -p1 -b .smtpstone 

# Apply PAM Patch
%if %{with pam}
%patch7 -p1 -b .pam
#rm -f README_FILES/PAM_README.pam
%endif

# Apply SMTPD Multiline greeting patch
%if %{with multiline}
%patch8 -p1 -b .multiline
%endif

%if %{with VDA}
%patch9 -p1 -b .vda
%patch10 -p1 -b .vda-bigquota
# vda patch does not add documentation to postfix-files
sed -i.vda -e '/readme_directory\/UUCP_README/a$readme_directory/VDA_README:f:root:-:644' conf/postfix-files
%endif

%patch11 -p1

install -m644 %{SOURCE10} README.mga
install -m644 %{SOURCE13} postfix-users-faq.html

mkdir UCE
install -m644 %{SOURCE25} UCE
install -m644 %{SOURCE26} UCE
install -m644 %{SOURCE27} UCE

%if %{with chroot}
cp -p conf/master.cf conf/master.cf.chroot
awk -v NEVER_CHROOT_PROGRAM='^(proxymap|local|pipe|virtual|spawn)$' \
	-v NEVER_CHROOT_SERVICE='^cyrus$' '
		BEGIN                   { IFS="[ \t]+"; OFS="\t"; }
		/^#/                    { print; next; }
		/^ /                    { print; next; }
		$1 ~ NEVER_CHROOT_SERVICE    { print; next; }
		$8 ~ NEVER_CHROOT_PROGRAM    { print; next; }
		$5 == "n"               { $5="y"; print $0; next; }
								{ print; }
	' conf/master.cf.chroot > conf/master.cf
%endif

# use sed to fix mantools/postlink for our non posix sed
#cp -p mantools/postlink mantools/postlink.posix
#sed -e 's/\[\[:<:\]\]/\\</g; s/\[\[:>:\]\]/\\>/g' mantools/postlink.posix > mantools/postlink
# XXX - andreas - original postlink with perl is segfaulting
cp -p mantools/postlink.sed mantools/postlink.posix
sed -e 's/\[\[:<:\]\]/\\</g; s/\[\[:>:\]\]/\\>/g' mantools/postlink.posix > mantools/postlink

%build
%serverbuild
OPT="$RPM_OPT_FLAGS"
DEBUG=
CCARGS=
AUXLIBS="%{?ldflags:%ldflags}"

# the patch is mixed with SDBM support :(
  CCARGS="${CCARGS} -DHAS_SDBM -DHAS_DLOPEN"

%if %{with ldap}
  CCARGS="${CCARGS} -DHAS_LDAP"
  AUXLIBS_LDAP="-lldap -llber"
%endif
%if %{with pcre}
  CCARGS="${CCARGS} -DHAS_PCRE"
  AUXLIBS_PCRE="$(pcre-config --libs)"
%endif
%if %{with mysql}
  CCARGS="${CCARGS} -DHAS_MYSQL -I/usr/include/mysql"
  AUXLIBS_MYSQL="-lmysqlclient"
%endif
%if %{with pgsql}
  CCARGS="${CCARGS} -DHAS_PGSQL -I/usr/include/pgsql"
  AUXLIBS_PGSQL="$(pkg-config --libs libpq)"
%endif
%if %{with sasl}
  CCARGS="${CCARGS} -DUSE_SASL_AUTH -DUSE_CYRUS_SASL -I/usr/include/sasl"
  AUXLIBS="${AUXLIBS} -lsasl2"
%endif
%if ! %{with ipv6}
  CCARGS="${CCARGS} -DNO_IPV6"
%endif
%if %{with tls}
  CCARGS="${CCARGS} -DUSE_TLS -I/usr/include/openssl"
  AUXLIBS="${AUXLIBS} -lssl -lcrypto"
%endif
%if %{with cdb}
  CCARGS="${CCARGS} -DHAS_CDB"
  AUXLIBS="${AUXLIBS} -lcdb"
%endif
%if %{with pam}
  CCARGS="${CCARGS} -DHAS_PAM"
%endif

export CCARGS AUXLIBS AUXLIBS_PCRE AUXLIBS_LDAP AUXLIBS_MYSQL AUXLIBS_PGSQL OPT DEBUG
make -f Makefile.init makefiles dynamicmaps=yes shlib_directory="%{_libdir}"

unset CCARGS AUXLIBS AUXLIBS_PCRE AUXLIBS_LDAP AUXLIBS_MYSQL AUXLIBS_PGSQL DEBUG OPT
make
make manpages

# generate main.cf.default here, since in make it will fail
cat > conf/main.cf.default << EOF
# DO NOT EDIT THIS FILE. EDIT THE MAIN.CF FILE INSTEAD. THE
# TEXT HERE JUST SHOWS DEFAULT SETTINGS BUILT INTO POSTFIX.
#
EOF
LD_LIBRARY_PATH=$PWD/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH} \
	./src/postconf/postconf -d | \
	egrep -v '^(myhostname|mydomain|mynetworks) ' >> conf/main.cf.default

# add correct parameters to main.cf.dist
LD_LIBRARY_PATH=$PWD/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH} \
	./src/postconf/postconf -c ./conf/dist -e \
	%post_install_parameters
mv conf/dist/main.cf conf/main.cf.dist

%install
# install postfix into the build root
LD_LIBRARY_PATH=$PWD/lib${LD_LIBRARY_PATH:+:$LD_LIBRARY_PATH} \
make non-interactive-package \
	install_root=%{buildroot} \
	config_directory=%{_sysconfdir}/postfix \
	%post_install_parameters \
	|| exit 1

mkdir -p %{buildroot}/var/lib/postfix

mkdir -p %{buildroot}%{_sysconfdir}/postfix/dynamicmaps.cf.d
mkdir -p %{buildroot}%{_sysconfdir}/postfix/postfix-files.d

# rpm %%doc macro wants to take his files in buildroot
rm -fr DOC
mkdir DOC
mv %{buildroot}%{_docdir}/%{name}/html DOC/html
mv %{buildroot}%{_docdir}/%{name}/README_FILES DOC/README_FILES

# for sasl configuration
mkdir -p %{buildroot}%{_sysconfdir}/sasl2
cp %{SOURCE15} %{buildroot}%{_sysconfdir}/sasl2/smtpd.conf

# This installs into the /etc/rc.d/init.d directory
mkdir -p %{buildroot}%{_initrddir}
install -c %{SOURCE3} %{buildroot}%{_initrddir}/postfix
mkdir -p %{buildroot}%{_sysconfdir}/pam.d
install -c %{SOURCE4} %{buildroot}%{_sysconfdir}/pam.d/smtp

mkdir -p %{buildroot}%{_sysconfdir}/ppp/ip-{up,down}.d
install -c %{SOURCE6} %{buildroot}%{_sysconfdir}/ppp/ip-up.d/postfix
install -c %{SOURCE7} %{buildroot}%{_sysconfdir}/ppp/ip-down.d/postfix

mkdir -p %{buildroot}%{_sysconfdir}/resolvconf/update-libc.d/
install -c %{SOURCE8} %{buildroot}%{_sysconfdir}/resolvconf/update-libc.d/postfix

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
touch %{buildroot}%{_sysconfdir}/sysconfig/postfix

# this is used by some examples (cyrus)
mkdir -p %{buildroot}%{queue_directory}/extern

install -c auxiliary/rmail/rmail %{buildroot}%{_bindir}/rmail

# copy new aliases files and generate a ghost aliases.db file
cp -f %{SOURCE5} %{buildroot}%{_sysconfdir}/postfix/aliases
chmod 644 %{buildroot}%{_sysconfdir}/postfix/aliases
touch %{buildroot}%{_sysconfdir}/postfix/aliases.db

touch %{buildroot}%{_sysconfdir}/postfix/domains

# install chroot script and postfinger
install -m 0755 %{SOURCE14} %{buildroot}%{_sbindir}/postfix-chroot.sh
install -m 0755 %{SOURCE21} %{buildroot}%{_sbindir}/postfinger

# install qshape
install -m755 auxiliary/qshape/qshape.pl %{buildroot}%{_sbindir}/qshape
cp man/man1/qshape.1 %{buildroot}%{_mandir}/man1/qshape.1

# use the /run
mkdir -p %{buildroot}/%{queue_directory}/run/saslauthd/

# RPM compresses man pages automatically.
# - Edit postfix-files to reflect this, so post-install won't get confused
#   when called during package installation.
sed -i -e "s@\(/man[158]/.*\.[158]\):@\1%{_extension}:@" %{buildroot}%{_sysconfdir}/postfix/postfix-files

# remove files that are not in the main package
sed -i -e "/postfix-.*\.so/d" %{buildroot}%{_sysconfdir}/postfix/postfix-files
# install the base configuration file
echo -e "# dict-type\tso-name (pathname)\tdict-function\tmkmap-function" > %{buildroot}%{_sysconfdir}/postfix/dynamicmaps.cf

# remove sample_directory from main.cf (#15297)
# the default is /etc/postfix
sed -i -e "/^sample_directory/d" %{buildroot}%{_sysconfdir}/postfix/main.cf

%if %{with sqlite}
cp -f src/global/postfix-sqlite.so %{buildroot}%{_libdir}/
%endif

%pre
%_pre_useradd postfix %{queue_directory} /bin/false
%_pre_groupadd %{maildrop_group} postfix
# disable chroot of spawn service in /etc/sysconfig/postfix,
# but do it only once and only if user did not
# modify /etc/sysconfig/postfix manually
if grep -qs "^NEVER_CHROOT_PROGRAM='^(proxymap|local|pipe|virtual)$'$" /etc/sysconfig/postfix; then
	if ! grep -qs "^NEVER_CHROOT_PROGRAM='^(proxymap|local|pipe|virtual|spawn)$'$" /usr/sbin/postfix-chroot.sh; then
		perl -pi -e "s/^NEVER_CHROOT_PROGRAM=.*\$/NEVER_CHROOT_PROGRAM=\'^(proxymap|local|pipe|virtual|spawn)\\\$\'/" /etc/sysconfig/postfix
	fi
fi
# disable some unneeded and potentially harmful nss libraries in
# /etc/sysconfig/postfix, but do it only once and only if user did not
# modify /etc/sysconfig/postfix manually
if grep -qs "^IGNORE_NSS_LIBS='^$'$" /etc/sysconfig/postfix; then
	if ! grep -qs "^IGNORE_NSS_LIBS='^(mdns.*|ldap|db|wins)$'$" /usr/sbin/postfix-chroot.sh; then
		perl -pi -e "s/^IGNORE_NSS_LIBS=.*\$/IGNORE_NSS_LIBS=\'^(mdns.*|ldap|db|wins)\\\$\'/" /etc/sysconfig/postfix
	fi
fi

%post
/usr/sbin/usermod -a -G mail postfix
#ensure the db files are created
%{_sbindir}/postmap /etc/postfix/virtual
%{_sbindir}/postmap /etc/postfix/domains

# we don't have these maps anymore as separate packages/plugins:
# cidr, tcp and sdbm (2007.0)
if [ "$1" -eq "2" ]; then
	sed -i "/^cidr/d;/^sdbm/d;/^tcp/d" %{_sysconfdir}/postfix/dynamicmaps.cf
fi

# daemon_directory changed in mga6, fix old config file if it was not replaced
if [ "$1" -eq "2" ]; then
	sed -i "s|^daemon_directory = .*|daemon_directory = %{_libexecdir}/postfix|" %{_sysconfdir}/postfix/main.cf
fi

# upgrade configuration files if necessary
%{_sbindir}/postfix \
	set-permissions \
	upgrade-configuration \
	config_directory=%{_sysconfdir}/postfix \
	%post_install_parameters

# move previous sasl configuration files to new location if applicable
# have to go through many loops to prevent damaging user configuration
# this changed around 2007.0 so it should go away soon
saslpath=`postconf -h smtpd_sasl_path`
if [ "${saslpath}" != "${saslpath##*:}" -o "${saslpath}" != "${saslpath##*/usr/lib}" ]; then
	postconf -e smtpd_sasl_path=smtpd
fi

for old_smtpd_conf in /etc/postfix/sasl/smtpd.conf %{_libdir}/sasl2/smtpd.conf; do
	if [ -e ${old_smtpd_conf} ]; then
		if ! grep -qsve '^\(#.*\|[[:space:]]*\)$' /etc/sasl2/smtpd.conf; then
			# /etc/sasl2/smtpd.conf missing or just comments
			if [ -s /etc/sasl2/smtpd.conf ] && [ ! -e /etc/sasl2/smtpd.conf.rpmnew -o /etc/sasl2/smtpd.conf -nt /etc/sasl2/smtpd.conf.rpmnew ]; then
				mv /etc/sasl2/smtpd.conf /etc/sasl2/smtpd.conf.rpmnew
			fi
			mv ${old_smtpd_conf} /etc/sasl2/smtpd.conf
		else
			echo "warning: existing ${old_smtpd_conf} will be ignored"
		fi
	fi
done

%if %{with tls}
%_create_ssl_certificate postfix
%endif

if [ -e /etc/sysconfig/postfix ]; then
	%{_sbindir}/postfix-chroot.sh -q update
else
%if %{with chroot}
	%{_sbindir}/postfix-chroot.sh -q enable
%else
	%{_sbindir}/postfix-chroot.sh -q create_sysconfig
%endif
fi
%_post_service postfix

%if %alternatives
/usr/sbin/update-alternatives --install %{_sbindir}/sendmail sendmail-command %{sendmail_command} 30 --slave %{_prefix}/lib/sendmail sendmail-command-in_libdir %{sendmail_command}
%endif

%triggerin -- glibc setup nss_ldap nss_db nss_wins nss_mdns
# Generate chroot jails on the fly when needed things are installed/upgraded
%{_sbindir}/postfix-chroot.sh -q update

%preun
rmqueue() {
	[ $2 -gt 0 ] || return
	local i
	for i in 0 1 2 3 4 5 6 7 8 9 A B C D E F; do
		if [ -d $1/$i ]; then
			rmqueue $1/$i $(( $2 - 1 ))
			rm -f $1/$i/*
			rmdir $1/$i
		fi
	done
}

# selectively remove the queue directory structure
queue_directory_remove () {
# first remove the "queues"
local IFS=', '
for dir in `%{_sbindir}/postconf -h hash_queue_names`; do
	test -d $dir && rmqueue %{queue_directory}/$dir `%{_sbindir}/postconf -h hash_queue_depth`
done

# now remove the other directories
for dir in corrupt maildrop pid private public trace; do
	test -d $dir && /bin/rm -f $dir/*
done
}

%_preun_service postfix

if [ $1 = 0 ]; then
	# Clean up chroot environment and spool directory
	%{_sbindir}/postfix-chroot.sh -q remove
	cd %{queue_directory} && queue_directory_remove || true
fi

%postun
%_postun_userdel postfix
%_postun_groupdel %{maildrop_group}
%if %alternatives
if [ ! -e %{sendmail_command} ]; then
	/usr/sbin/update-alternatives --remove sendmail-command %{sendmail_command} 
fi
%endif

%files
%dir %{_sysconfdir}/postfix
%config(noreplace) %{_sysconfdir}/sasl2/smtpd.conf
%config(noreplace) %{_sysconfdir}/postfix/main.cf
# http://archives.mandrivalinux.com/cooker/2005-07/msg01109.php
%{_sysconfdir}/postfix/main.cf.dist
%{_sysconfdir}/postfix/main.cf.default
%{_sysconfdir}/postfix/main.cf.proto
%{_sysconfdir}/postfix/bounce.cf.default
%config(noreplace) %{_sysconfdir}/postfix/master.cf
%config(noreplace) %{_sysconfdir}/postfix/access
%config(noreplace) %{_sysconfdir}/postfix/aliases
%ghost %{_sysconfdir}/postfix/aliases.db
%config(noreplace) %{_sysconfdir}/postfix/canonical
%config(noreplace) %{_sysconfdir}/postfix/domains
%config(noreplace) %{_sysconfdir}/postfix/generic
%config(noreplace) %{_sysconfdir}/postfix/header_checks
%config(noreplace) %{_sysconfdir}/postfix/relocated
%config(noreplace) %{_sysconfdir}/postfix/transport
%config(noreplace) %{_sysconfdir}/postfix/virtual
%{_sysconfdir}/postfix/makedefs.out
%dir %{_sysconfdir}/postfix/dynamicmaps.cf.d/
%config(noreplace) %{_sysconfdir}/postfix/dynamicmaps.cf
%attr(0755, root, root) %{_initrddir}/postfix
%attr(0644, root, root) %config(noreplace) %{_sysconfdir}/pam.d/smtp
%attr(0755, root, root) %config(noreplace) %{_sysconfdir}/ppp/ip-up.d/postfix
%attr(0755, root, root) %config(noreplace) %{_sysconfdir}/ppp/ip-down.d/postfix
%attr(0755, root, root) %config(noreplace) %{_sysconfdir}/resolvconf/update-libc.d/postfix
%ghost %{_sysconfdir}/sysconfig/postfix
%attr(0755, root, root) %{queue_directory}/run/saslauthd/

%dir %attr(0700, postfix, root) /var/lib/postfix

# For correct directory permissions check postfix-install script
%dir %{queue_directory}
%dir %attr(0700, postfix, root) %{queue_directory}/active
%dir %attr(0700, postfix, root) %{queue_directory}/bounce
%dir %attr(0700, postfix, root) %{queue_directory}/corrupt
%dir %attr(0700, postfix, root) %{queue_directory}/defer
%dir %attr(0700, postfix, root) %{queue_directory}/deferred
%dir %attr(0700, postfix, root) %{queue_directory}/flush
%dir %attr(0700, postfix, root) %{queue_directory}/hold
%dir %attr(0700, postfix, root) %{queue_directory}/incoming
%dir %attr(0700, postfix, root) %{queue_directory}/private
%dir %attr(0700, postfix, root) %{queue_directory}/trace
%dir %attr(0730, postfix, %{maildrop_group}) %{queue_directory}/maildrop
%dir %attr(0710, postfix, %{maildrop_group}) %{queue_directory}/public
%dir %attr(0755, root, root) %{queue_directory}/pid
%dir %attr(0755, root, root) %{queue_directory}/extern

%doc AAAREADME
%doc US_PATENT_6321267
%doc examples/smtpd-policy
%doc COMPATIBILITY
%doc COPYRIGHT
%doc HISTORY
%doc LICENSE
%doc PORTING
%doc RELEASE_NOTES*
%doc IPv6-ChangeLog
%doc TLS_*
#doc html
%doc DOC/html
%doc DOC/README_FILES
%doc README.mga
%doc postfix-users-faq.html
%doc UCE

%dir %{_libexecdir}/postfix
%attr(0644, root, root) %{_sysconfdir}/postfix/master.cf.proto
%dir %{_sysconfdir}/postfix/postfix-files.d/
%attr(0644, root, root) %{_sysconfdir}/postfix/postfix-files
%attr(0755, root, root) %{_libexecdir}/postfix/anvil
%attr(0755, root, root) %{_libexecdir}/postfix/bounce
%attr(0755, root, root) %{_libexecdir}/postfix/cleanup
%attr(0755, root, root) %{_libexecdir}/postfix/discard
%attr(0755, root, root) %{_libexecdir}/postfix/dnsblog
%attr(0755, root, root) %{_libexecdir}/postfix/error
%attr(0755, root, root) %{_libexecdir}/postfix/flush
%attr(0755, root, root) %{_libexecdir}/postfix/lmtp
%attr(0755, root, root) %{_libexecdir}/postfix/local
%attr(0755, root, root) %{_libexecdir}/postfix/master
%attr(0755, root, root) %{_libexecdir}/postfix/nqmgr
%attr(0755, root, root) %{_libexecdir}/postfix/oqmgr
%attr(0755, root, root) %{_libexecdir}/postfix/pickup
%attr(0755, root, root) %{_libexecdir}/postfix/pipe
%attr(0755, root, root) %{_libexecdir}/postfix/postfix-script
%attr(0755, root, root) %{_libexecdir}/postfix/postfix-tls-script
%attr(0755, root, root) %{_libexecdir}/postfix/postfix-wrapper
%attr(0755, root, root) %{_libexecdir}/postfix/post-install
%attr(0755, root, root) %{_libexecdir}/postfix/postmulti-script
%attr(0755, root, root) %{_libexecdir}/postfix/postscreen
%attr(0755, root, root) %{_libexecdir}/postfix/proxymap
%attr(0755, root, root) %{_libexecdir}/postfix/qmgr
%attr(0755, root, root) %{_libexecdir}/postfix/qmqpd
%attr(0755, root, root) %{_libexecdir}/postfix/scache
%attr(0755, root, root) %{_libexecdir}/postfix/showq
%attr(0755, root, root) %{_libexecdir}/postfix/smtp
%attr(0755, root, root) %{_libexecdir}/postfix/smtpd
%attr(0755, root, root) %{_libexecdir}/postfix/spawn
%attr(0755, root, root) %{_libexecdir}/postfix/tlsmgr
%attr(0755, root, root) %{_libexecdir}/postfix/tlsproxy
%attr(0755, root, root) %{_libexecdir}/postfix/trivial-rewrite
%attr(0755, root, root) %{_libexecdir}/postfix/verify
%attr(0755, root, root) %{_libexecdir}/postfix/virtual

%attr(0755, root, root) %{_sbindir}/postalias
%attr(0755, root, root) %{_sbindir}/postcat
%attr(0755, root, root) %{_sbindir}/postconf
%attr(2755,root,%{maildrop_group}) %{_sbindir}/postdrop
%attr(2755,root,%{maildrop_group}) %{_sbindir}/postqueue
%attr(0755, root, root) %{_sbindir}/postfix
%attr(0755, root, root) %{_sbindir}/postkick
%attr(0755, root, root) %{_sbindir}/postlock
%attr(0755, root, root) %{_sbindir}/postlog
%attr(0755, root, root) %{_sbindir}/postmap
%attr(0755, root, root) %{_sbindir}/postmulti
%attr(0755, root, root) %{_sbindir}/postsuper
%attr(0755, root, root) %{_sbindir}/qmqp-sink
%attr(0755, root, root) %{_sbindir}/qmqp-source
%attr(0755, root, root) %{_sbindir}/smtp-sink
%attr(0755, root, root) %{_sbindir}/smtp-source
%attr(0755, root, root) %{_sbindir}/postfinger
%attr(0755, root, root) %{_sbindir}/postfix-chroot.sh
%attr(0755, root, root) %{_sbindir}/qshape
%attr(0755, root, root) %{sendmail_command}
%{_bindir}/mailq
%{_bindir}/newaliases
%attr(0755, root, root) %{_bindir}/rmail
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man8/*

%files -n %{libname}
%{_libdir}/libpostfix-dns.so
%{_libdir}/libpostfix-global.so
%{_libdir}/libpostfix-master.so
%{_libdir}/libpostfix-util.so
%{_libdir}/libpostfix-tls.so

%if %{with ldap}
%files ldap
%attr(755, root, root) %{_libdir}/postfix-ldap.so

%post ldap
%dynmap_add_cmd ldap
%postun ldap
%dynmap_rm_cmd ldap
%endif

%if %{with mysql}
%files mysql
%attr(755, root, root) %{_libdir}/postfix-mysql.so 

%post mysql
%dynmap_add_cmd mysql
%postun mysql
%dynmap_rm_cmd mysql
%endif

%if %{with pam}
%files pam
%attr(755, root, root) %{_libdir}/postfix-pam.so

%post pam
%dynmap_add_cmd pam
%postun pam
%dynmap_rm_cmd pam
%endif

%if %{with sdbm}
%files sdbm
%attr(755, root, root) %{_libdir}/postfix-sdbm.so 

%post sdbm
%dynmap_add_cmd sdbm
%postun sdbm
%dynmap_rm_cmd sdbm
%endif

%if %{with pcre}
%files pcre
%attr(755, root, root) %{_libdir}/postfix-pcre.so

%post pcre
%dynmap_add_cmd pcre
%postun pcre
%dynmap_rm_cmd pcre
%endif

%if %{with pgsql}
%files pgsql
%attr(755, root, root) %{_libdir}/postfix-pgsql.so

%post pgsql
%dynmap_add_cmd pgsql
%postun pgsql
%dynmap_rm_cmd pgsql
%endif

%if %{with sqlite}
%files sqlite
%attr(755, root, root) %{_libdir}/postfix-sqlite.so

%post sqlite
%dynmap_add_cmd sqlite
%postun sqlite
%dynmap_rm_cmd sqlite
%endif

%if %{with cdb}
%files cdb
%attr(755, root, root) %{_libdir}/postfix-cdb.so

%post cdb
%dynmap_add_cmd cdb -m
%postun cdb
%dynmap_rm_cmd cdb
%endif


%changelog
* Mon Mar 20 2017 akien <akien> 1:3.1.4-2.mga6
+ Revision: 1093680
- Rebuild for icu 58.2

* Tue Jan 03 2017 luigiwalser <luigiwalser> 1:3.1.4-1.mga6
+ Revision: 1079921
- 3.1.4

* Sun Oct 02 2016 luigiwalser <luigiwalser> 1:3.1.3-1.mga6
+ Revision: 1058147
- 3.1.3

* Fri Sep 02 2016 wally <wally> 1:3.1.2-2.mga6
+ Revision: 1049779
- create /etc/postfix/postfix-files.d/ and /etc/postfix/dynamicmaps.cf.d/ to suppress post-install errors

* Sun Aug 28 2016 luigiwalser <luigiwalser> 1:3.1.2-1.mga6
+ Revision: 1049359
- 3.1.2

* Tue May 17 2016 luigiwalser <luigiwalser> 1:3.1.1-1.mga6
+ Revision: 1016469
- 3.1.1

* Fri May 13 2016 shlomif <shlomif> 1:3.1.0-4.mga6
+ Revision: 1014912
- Rebuild for new ICU

* Thu Mar 03 2016 umeabot <umeabot> 1:3.1.0-3.mga6
+ Revision: 983911
- Rebuild for openssl

* Sun Feb 28 2016 oden <oden> 1:3.1.0-2.mga6
+ Revision: 980344
- rebuilt for postgresql 9.5.x

* Fri Feb 26 2016 luigiwalser <luigiwalser> 1:3.1.0-1.mga6
+ Revision: 979586
- 3.1.0
- enable postfix 3.0 default compatibility level in main.cf

* Mon Feb 22 2016 luigiwalser <luigiwalser> 1:3.0.4-1.mga6
+ Revision: 976049
- 3.0.4

* Tue Jan 26 2016 luigiwalser <luigiwalser> 1:3.0.3-5.mga6
+ Revision: 927667
- add patch to not print warning messages about writable permissions on symlinks

* Thu Jan 21 2016 luigiwalser <luigiwalser> 1:3.0.3-4.mga6
+ Revision: 926253
- fix sed command

* Wed Jan 20 2016 luigiwalser <luigiwalser> 1:3.0.3-3.mga6
+ Revision: 926151
- do not install incorrect dynamicmaps.cf file from source tarball
- fix daemon_directory in existing main.cf config on upgrade

* Thu Jan 14 2016 luigiwalser <luigiwalser> 1:3.0.3-2.mga6
+ Revision: 923014
- fix daemon_directory in main.cf

* Thu Jan 14 2016 luigiwalser <luigiwalser> 1:3.0.3-1.mga6
+ Revision: 922908
- 3.0.3 (partial sync with omdv)

* Tue Oct 20 2015 blino <blino> 1:2.10.3-6.mga6
+ Revision: 892922
- support building from a Linux 4 kernel (extracted from upstream postfix-3.1-20150523)

* Fri Mar 13 2015 luigiwalser <luigiwalser> 1:2.10.3-5.mga5
+ Revision: 818485
- rebuild against openssl 1.0.2 (mga#15477)

* Tue Nov 25 2014 cjw <cjw> 1:2.10.3-4.mga5
+ Revision: 799088
- rebuild against postgresql9.4

* Wed Oct 15 2014 umeabot <umeabot> 1:2.10.3-3.mga5
+ Revision: 746979
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1:2.10.3-2.mga5
+ Revision: 687730
- Mageia 5 Mass Rebuild

* Fri Sep 05 2014 luigiwalser <luigiwalser> 1:2.10.3-1.mga5
+ Revision: 672341
- 2.10.3

* Sun Apr 27 2014 blino <blino> 1:2.10.2-3.mga5
+ Revision: 618436
- fix saslauthd_path in sasl2/smtpd.conf

* Sat Oct 19 2013 umeabot <umeabot> 1:2.10.2-2.mga4
+ Revision: 533788
- Mageia 4 Mass Rebuild

* Fri Sep 06 2013 luigiwalser <luigiwalser> 1:2.10.2-1.mga4
+ Revision: 475438
- 2.10.2

* Tue Aug 27 2013 luigiwalser <luigiwalser> 1:2.10.1-2.mga4
+ Revision: 472085
- rebuild for cyrus-sasl

* Thu Aug 22 2013 luigiwalser <luigiwalser> 1:2.10.1-1.mga4
+ Revision: 469692
- 2.10.1
- rediff patches 0 and 1 (from omdv)

* Thu Jul 11 2013 danf <danf> 1:2.9.6-5.mga4
+ Revision: 452686
- enable opportunistic TLS on outgoing SMTP connections in the default
  configuration
- updated a few things in postfix-README.MGA

* Thu May 09 2013 colin <colin> 1:2.9.6-4.mga3
+ Revision: 412777
- Don't make bind mounting absolutely required and don't munge exit value (see r312359).

* Mon Apr 22 2013 dlucio <dlucio> 1:2.9.6-3.mga3
+ Revision: 410962
- fixes #9789

* Tue Mar 26 2013 colin <colin> 1:2.9.6-2.mga3
+ Revision: 405409
- Require system-logger rather than syslog-daemon mga#8028

* Wed Feb 06 2013 luigiwalser <luigiwalser> 1:2.9.6-1.mga3
+ Revision: 394770
- 2.9.6

* Sun Jan 13 2013 umeabot <umeabot> 1:2.9.5-3.mga3
+ Revision: 378094
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Jan 11 2013 dlucio <dlucio> 1:2.9.5-2.mga3
+ Revision: 345044
- P1 rediffed to fix #7391
- Some cleanings of remainding Mandriva prefixes

* Tue Dec 25 2012 luigiwalser <luigiwalser> 1:2.9.5-1.mga3
+ Revision: 334787
- 2.9.5

* Sat Dec 01 2012 fwang <fwang> 1:2.9.4-3.mga3
+ Revision: 323833
- rebuild for new pcre

* Fri Nov 02 2012 dlucio <dlucio> 1:2.9.4-2.mga3
+ Revision: 312361
- P1 rediffed
- lets support sasl again with mount bind

* Fri Sep 07 2012 luigiwalser <luigiwalser> 1:2.9.4-1.mga3
+ Revision: 289608
- 2.9.4

* Tue Jul 31 2012 fwang <fwang> 1:2.9.3-3.mga3
+ Revision: 276309
- rebuild for db-5.3

* Fri Jul 20 2012 dlucio <dlucio> 1:2.9.3-2.mga3
+ Revision: 272828
- P0 rediffed, merci Mandriva

* Mon Jul 16 2012 dlucio <dlucio> 1:2.9.3-1.mga3
+ Revision: 271205
- 2.9.3
- Update to 2.9.1
- P0 rediffed
- P1 rediffed
- P3 rediffed
- P5 added in order to use original P0
- P11 merged upstream
- We add support for sqlite

  + guillomovitch <guillomovitch>
    - rename distribution-specific readme file once again to README.mga, for consistency

* Sun Feb 19 2012 luigiwalser <luigiwalser> 1:2.8.8-1.mga2
+ Revision: 210583
- 2.8.8
- fix creation of /etc/sysconfig/postfix on clean install (mdv #65025)
- add openssl dependancy for certificate generation on install (from mdv)
- fix README.MGA filename

  + guillomovitch <guillomovitch>
    - rename distribution-specific file to README.mga, and don't advertise it in package description

* Sun Jan 01 2012 dmorgan <dmorgan> 1:2.8.7-3.mga2
+ Revision: 189416
- Remove some MDK and add back README.MGA.update
- Remove some %%if Mandriva

* Sat Dec 17 2011 dlucio <dlucio> 1:2.8.7-2.mga2
+ Revision: 183376
- fixes

* Fri Dec 16 2011 dlucio <dlucio> 1:2.8.7-1.mga2
+ Revision: 182675
- 2.8.7

* Tue Oct 25 2011 dlucio <dlucio> 1:2.8.6-1.mga2
+ Revision: 158099
- SPEC fixes,
  > some modifications to make compatible this SPEC with mageia, not finished yet

* Sun Oct 02 2011 dlucio <dlucio> 1:2.7.4-4.mga2
+ Revision: 150943
- Fixing Bug 2655

  + remmy <remmy>
    - Delete postfix-README.MGA.update file
    - Revert mdvsys --> mgarepo change in spec file
    - Clean up of spec file
    - Remove "Mandriva Linux" from banner (closes bug #1800)
    - Minor documentation update
    - Various other fixes of Mandriva references

* Mon Jul 04 2011 rapsys <rapsys> 1:2.7.4-2.mga2
+ Revision: 118349
- Cleanup old syslog-ng cruft
  Remove %%changelog (automaticaly added)
  Rename mdk file to mga

* Tue May 17 2011 dmorgan <dmorgan> 1:2.7.4-1.mga1
+ Revision: 99522
- New version 2.7.4
  create /dev/urandom in chroot (#62851) ( mdv commit 647659 )
  fix man ext ( mdv commit 653114 )

* Fri Mar 25 2011 dmorgan <dmorgan> 1:2.7.1-4.mga1
+ Revision: 77247
- Rebuild against new mysql

* Sat Jan 22 2011 ennael <ennael> 1:2.7.1-3.mga1
+ Revision: 33035
- fix boggus commits
- remove last mdkversion
- remove mdk versions
- imported package postfix

